from connect import *
import clr
import System.Array
import math

beam_set = get_current("BeamSet")

def getStandardDeviation(array):

    mean = sum(array)/len(array)
    deviation = []
    for x in array:
        devi = (x-mean)*(x-mean)
        deviation.append(devi)
    mean_deviation = sum(deviation)/len(deviation)
    
    return math.sqrt(mean_deviation)


def CheckMLCLimit(beam_set):
    Beams = beam_set.Beams.Count
    CurrentBeam = 0
    averagelist = []
    averagelistSTD = []
	averageopenfields = []
	sumopenfieldperbeam = []
	sumsegmentsperbeam = []

    while Beams > CurrentBeam:
        ActiveBeam = beam_set.Beams[CurrentBeam]
        SegmentCount = ActiveBeam.Segments.Count                # 90 segmenter = SegmentCount
        SCounter = 0

        list_distances = []					# list of MLC flank distances for all the leafs in one segment
        gjliste = []						# list of average MLC flank distances for all the segments (average of 'list_distances')
        openfields = []						# list of #opened fields per segment, containing all the segments

        while SCounter < SegmentCount:       # operation for each segment
            Leaves = ActiveBeam.Segments[SCounter].LeafPositions
            Lcounter=0
            OpenFieldCounter = 1

            #assuming the same # of leaves on each bank
            start = int((20+(ActiveBeam.Segments[SCounter].JawPositions[2]))*2)		# start leaf = int([20+(-10.5)]*2) = 19
            stop = int(80-(20-ActiveBeam.Segments[SCounter].JawPositions[3])*2)-1	# stop leaf = int(80-[20-8.5]*2)-1 = 56
			  
            for i in range(start, stop, 1):               # going through all the leafs between start and stop

                if ((Leaves[0][i+1] < Leaves[1][i]) and (Leaves[0][i] < Leaves[1][i+1])):		# "ordinary" MLC opening
                    if Leaves[1][i] >= Leaves[1][i+1]:
                        distance1 = Leaves[1][i] - Leaves[1][i+1]		# right MLC leaf
                        list_distances.append(distance1)

                    if Leaves[1][i+1] > Leaves[1][i]:
                        distance1 = Leaves[1][i+1] - Leaves[1][i]  		# right MLC leaf
                        list_distances.append(distance1)

                    if Leaves[0][i] >= Leaves[0][i+1]:
                        distance0 = Leaves[0][i] - Leaves[0][i+1]    	# left MLC leaf
                        list_distances.append(distance0)

                    if Leaves[0][i+1] > Leaves[0][i]:
                        distance0 = Leaves[0][i+1] - Leaves[0][i]		# left MLC leaf
                        list_distances.append(distance0)
					
                elif ((Leaves[0][i+1] <= Leaves[1][i]) and (Leaves[0][i] >= Leaves[1][i+1])):	# overlapping --> OpenFieldCounter += 1
                    # right MLC leaf:
					distance1 = (Leaves[0][i] - Leaves[1][i])
                    list_distances.append(distance1)		# add to list containing MLC flank distances
					# left MLC leaf:
                    distance0 = (Leaves[0][i+1] - Leaves[1][i+1])
                    list_distances.append(distance0)		# add to list containing MLC flank distances
                    OpenFieldCounter += 1

                elif ((Leaves[0][i+1] <= Leaves[1][i]) and (Leaves[0][i] <= Leaves[1][i+1])):
                    # right MLC leaf
					distance1 = (Leaves[1][i] - Leaves[0][i])
                    list_distances.append(distance1)
					# left MLC leaf
                    distance0 = (Leaves[1][i+1] - Leaves[0][i+1])
                    list_distances.append(distance0)
                    OpenFieldCounter += 1

                elif (Leaves[0][i+1] >= Leaves[1][i]):											# overlapping --> OpenFieldCounter += 1
                    # right MLC leaf:
					distance1 = (Leaves[1][i] - Leaves[0][i])
                    list_distances.append(distance1)		# add to list containing MLC flank distances
					# left MLC leaf:
                    distance0 = (Leaves[1][i+1] - Leaves[0][i+1])
                    list_distances.append(distance0)		# add to list containing MLC flank distances
                    OpenFieldCounter += 1
			 
			# now the list 'list_distances' contains all the MLC flank distances for this segment
			# want to find the average distance for this segment:
            gjsnitt = sum(list_distances)/len(list_distances)		
            gjliste.append(gjsnitt)			# add the average flank distance for this segment to the list 'gjsnitt'

			# OpenFieldCounter = number of opened fields for this segment
            openfields.append(OpenFieldCounter)		# add OpenFieldCounter to the list 'openfields'
            print 'OpenFieldCounter for segment{0}: '.format(SCounter)
            print OpenFieldCounter   

            SCounter += 1       


        tot_gjsnitt = sum(gjliste)/len(gjliste)		# finding the average flank distance for the beam
        CurrentBeam += 1

        print "Mean MLC flank for beam no. {0}:".format(CurrentBeam)
        print tot_gjsnitt
        print 'Standard deviation:'
        STD = getStandardDeviation(gjliste)
        print STD

        averagelist.append(tot_gjsnitt)				# add the average flank distance for the beam to the list 'averagelist'
        averagelistSTD.append(STD)
		
		sumopenfieldperbeam.append(sum(openfields))
		#gjopenfields = sum(openfields)/len(openfields)
		sumsegmentsperbeam.append(len(openfields))
		#averageopenfields.append(gjopenfields)


    print "- - - - - - - - - - "
	print "Average distance: "
    print averagelist						# prints the average distances for each beam, presented in a list
    print sum(averagelist)/len(averagelist)	# prints the average distances for all the beams
    print "Average STD: "
    print averagelistSTD
    print sum(averagelistSTD)/len(averagelistSTD)
    print "Number of open fields for each beam: "
	print sumopenfieldperbeam
	print "Segments per beam: "
    print sumsegmentsperbeam

#connect(10672)
print CheckMLCLimit(get_current('BeamSet'))
