from connect import *
import clr
import System.Array
import math

beam_set = get_current("BeamSet")

def getStandardDeviation(array):

    mean = sum(array)/len(array)
    deviation = []
	for x in array:
		devi = (x-mean)*(x-mean)
		deviation.append(devi)
    mean_deviation = sum(deviation)/len(deviation)
    
    return math.sqrt(mean_deviation)


def CheckMLCLimit(beam_set):

    Beams = beam_set.Beams.Count
    CurrentBeam = 0
    tot_gjsnitt_list = []
    listSTD = []

    while Beams > CurrentBeam:
         ActiveBeam = beam_set.Beams[CurrentBeam]

         SegmentCount = ActiveBeam.Segments.Count			# 90 segmenter = SegmentCount
         SCounter = 0
         gjliste = []

         while SCounter < SegmentCount:						# operation for each segment
              start = int((20+(ActiveBeam.Segments[SCounter].JawPositions[2]))*2)		# start leaf = int([20+(-10.5)]*2) = 19
              stop = int(80-(20-ActiveBeam.Segments[SCounter].JawPositions[3])*2)		# stop leaf = int(80 - [20-8.5]*2) = 57
  
              leaf_positions = ActiveBeam.Segments[SCounter].LeafPositions 
              distances = [rp - lp for lp, rp in zip(leaf_positions[0][start:stop], leaf_positions[1][start:stop])] 

              gjsnitt = sum(distances)/len(distances)		# finds average value of the distances between the MLC leafs for one segment
              gjliste.append(gjsnitt)						# adds the average value of the distances to the list 'gjliste'

              SCounter += 1            


         tot_gjsnitt = sum(gjliste)/len(gjliste)			# finds the total average of the distances for all segments in one beam
         STD = getStandardDeviation(gjliste)				# finds the STD of the distances for all segments in one beam
		 
         tot_gjsnitt_list.append(tot_gjsnitt)
         listSTD.append(STD)

		 print 'Amount of MLC leafs'
         print len(leaf_positions[0][start:stop])

         print "Mean distance between the MLC leafs, and STD, for beam no. {0}:".format(CurrentBeam)
         print tot_gjsnitt
         print STD

         CurrentBeam += 1

# Average of the beams:
    print '- - - - - '
    print "Average mean distance between the MLC leafs:"
    print sum(tot_gjsnitt_list)/len(tot_gjsnitt_list)
    print "Average standard deviation:"
    print sum(listSTD)/len(listSTD)

#connect(10672)
print CheckMLCLimit(get_current('BeamSet'))

