from connect import *
import clr
import System.Array
import math

beam_set = get_current("BeamSet")

def getStandardDeviation(array):

    mean = sum(array)/len(array)
    deviation = []
    for x in array:
       devi = (x-mean)*(x-mean)
       deviation.append(devi)
    mean_deviation = sum(deviation)/len(deviation)
    
    return math.sqrt(mean_deviation)


def CheckMLCLimit(beam_set):

    Beams = beam_set.Beams.Count
    CurrentBeam = 0
    averagelist = []
    averagelistSTD = []

    while Beams > CurrentBeam:
         ActiveBeam = beam_set.Beams[CurrentBeam]

         SegmentCount = (ActiveBeam.Segments.Count - 1)               # 90 segmenter = SegmentCount
         SCounter = 0
         gjliste1 = []
         gjliste2 = []

         while SCounter < SegmentCount:       # operation for each segment
              Leaves = ActiveBeam.Segments[SCounter].LeafPositions
              Lcounter=0
              #assuming the same # of leaves on each bank

              start = int((20+(ActiveBeam.Segments[SCounter].JawPositions[2]))*2)		# start leaf = int([20+(-10.5)]*2) = 19
              stop = int(80-(20-ActiveBeam.Segments[SCounter].JawPositions[3])*2) - 1	# stop leaf = int(80-[20-8.5]*2)-1 = 56

			# Left MLC leafs:
              leaf_1 = ActiveBeam.Segments[SCounter].LeafPositions[0][start:stop]
              leaf_2 = ActiveBeam.Segments[SCounter+1].LeafPositions[0][start:stop]
              distances = [abs(rp - lp) for lp, rp in zip(leaf_1, leaf_2)]
              
              gjsnitt1 = sum(distances)/len(distances)	# finds average value of the "speed" between two segment, for left MLC leafs
              gjliste1.append(gjsnitt1)					# adds the average speed value (for left MLC leafs) to the list 'gjliste1'

			# Right MLC leafs:
              leaf_1 = ActiveBeam.Segments[SCounter].LeafPositions[1][start:stop]
              leaf_2 = ActiveBeam.Segments[SCounter+1].LeafPositions[1][start:stop]
              distances = [abs(rp - lp) for lp, rp in zip(leaf_1, leaf_2)]
              
              gjsnitt2 = sum(distances)/len(distances)	# finds average value of the "speed" between two segment, for right MLC leafs
              gjliste2.append(gjsnitt2)					# adds the average speed value (for right MLC leafs) to the list 'gjliste2'

              SCounter += 1            


         tot_gjsnitt_1 = sum(gjliste1)/len(gjliste1)	# finds total average speed for all segments (left MLC leafs)
         tot_gjsnitt_2 = sum(gjliste2)/len(gjliste2)	# finds total average speed for all segments (right MLC leafs)

         CurrentBeam += 1

         print "Mean distance between neighboring MLC leafs ([0][j] - [0][j+1]) for beam no. {0}:".format(CurrentBeam)
         print tot_gjsnitt_1
         print 'Standard deviation:'
         STD1 = getStandardDeviation(gjliste1)
         print STD1

         print "Mean distance between neighboring MLC leafs ([1][j] - [1][j+1]) for beam no. {0}:".format(CurrentBeam)
         print tot_gjsnitt_2
         print 'Standard deviation:'
         STD2 = getStandardDeviation(gjliste2)
         print STD2

         averagelist.append(tot_gjsnitt_1)
         averagelist.append(tot_gjsnitt_2)
         averagelistSTD.append(STD1)
         averagelistSTD.append(STD2)

    print "- - - - - - - - - -"
    print "Average distance: "
    print sum(averagelist)/len(averagelist)
    print "Average STD: "
    print sum(averagelistSTD)/len(averagelistSTD)

#connect(10672)
print CheckMLCLimit(get_current('BeamSet'))
